// tslint:disable-next-line:import-blacklist
import {cloneDeep as _cloneDeep} from 'lodash';

export namespace runtime {
  export function invokeAsPromiseIfPossible(functionToInvoke: any, invocationContext: any, invocationParameter?: Array<any>): Promise<any> {

    return new Promise((resolve: any, reject: any): void => {
      if (!isValidFunction(functionToInvoke)) {
        return resolve();
      }

      let result: any;
      try {
        result = functionToInvoke.call(invocationContext, invocationParameter);
      } catch (error) {
        return reject(error);
      }

      resolve(result);
    });
  }

  export function cloneDeep<T = any>(inputObject: T): T {
    return _cloneDeep(inputObject);
  }

  function isValidFunction(inputFunction: any): boolean {
    const functionIsValid: boolean = inputFunction !== undefined &&
                                     inputFunction !== null &&
                                     typeof inputFunction === 'function';

    return functionIsValid;
  }
}
